﻿var hosts = [];

function createHost(host) {
    $.postJSON("/api/host", host).then((res, status) => {
        console.log("POSTED" + status, res);
        if (status === "success") {
            fetchHosts();
        }
    });
}

function deleteHost(hostId) {
    $.ajax({
        url: "/api/host/"+hostId,
        type: "DELETE"
    }).then(() => {
        console.log("DELETED");
        fetchHosts();
    });
}

function fetchHosts() {
    var tbody = $("#tblHosts > tbody");
    tbody.empty();
    $.getJSON("/api/host").then((res) => {
        console.log("Got hosts: ", res);
        for (let host of res) {
            var row = $("<tr>",).appendTo(tbody);
            $("<td>").text(host.hostId).appendTo(row);
            $("<td>").text(host.name).appendTo(row);
            $("<td>").text(host.hostName).appendTo(row);
            $("<td>").text("Delete").click(() => {
                deleteHost(host.hostId);
                }).appendTo(row);
        }
    });
}

$('#btnDebug').click(function () {
    console.log("DEBUG");
    $.getJSON("/api/host/" + id + "/pings/" + Date.now + "/" + Date.now).then((res) => {
        console.log("CALLED: res ", res);
    });
});

$('#btnHostAdd').click(function () {
    var name = $("#inpNameAdd").val();
    var hostname = $("#inpHostNameAdd").val();
    var host = {
        name: name,
        hostname: hostname
    }
    createHost(host);
});

fetchHosts();

jQuery["postJSON"] = function (url, data, callback) {
    // shift arguments if data argument was omitted
    if (jQuery.isFunction(data)) {
        callback = data;
        data = undefined;
    }

    if (data) {
        if (typeof data === 'string') {
            data = JSON.stringify(data);
        }
    }

    return jQuery.ajax({
        url: url,
        type: "POST",
        contentType: "application/json; charset=utf-8",
        dataType: "json",
        data: JSON.stringify(data),
        success: callback
    });
};